import { Document, Schema, model } from 'mongoose';

export interface TierInterface extends Document {
  id: number,
  resourceLimits: {
    // in MB
    ram: number,
    // in MB
    storage: number,
  },
}

const Tier: Schema = new Schema({
  id: Number,
  resourceLimits: {
    ram: Number,
    storage: Number,
  },
}, { id: false });

export default model<TierInterface>('Tier', Tier);
